
/*
 * CS5600 University of Utah
 * Charles McGarvey
 * mcgarvey@eng.utah.edu
 */

#ifndef _SCENE_H_
#define _SCENE_H_

#include "raster.h"


/*
 * A scene class.
 */
typedef struct scene scene_t;

/*
 * Allocate a scene by reading in data from a file.
 */
scene_t* scene_alloc(FILE* file);

/*
 * Destroy a scene.
 */
void scene_destroy(scene_t* s);


/*
 * Render a scene to an in-memory raster.  The caller takes ownership of the
 * returned object and must destroy it when it is no longer needed.
 */
raster_t* scene_render(scene_t* s);


#endif // _SCENE_H_

